=begin
#Bleumi Pay REST API

#A simple and powerful REST API to integrate ERC-20, Ethereum, xDai, Algorand payments and/or payouts into your business or application

The version of the OpenAPI document: 1.0.0
Contact: info@bleumi.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.2.2

=end

# Common files
require 'bleumi_pay_sdk_ruby/api_client'
require 'bleumi_pay_sdk_ruby/api_error'
require 'bleumi_pay_sdk_ruby/version'
require 'bleumi_pay_sdk_ruby/configuration'

# Models
require 'bleumi_pay_sdk_ruby/models/algorand_address'
require 'bleumi_pay_sdk_ruby/models/algorand_balance'
require 'bleumi_pay_sdk_ruby/models/algorand_wallet_address'
require 'bleumi_pay_sdk_ruby/models/algorand_wallet_inputs'
require 'bleumi_pay_sdk_ruby/models/bad_request'
require 'bleumi_pay_sdk_ruby/models/chain'
require 'bleumi_pay_sdk_ruby/models/checkout_token'
require 'bleumi_pay_sdk_ruby/models/create_checkout_url_request'
require 'bleumi_pay_sdk_ruby/models/create_checkout_url_response'
require 'bleumi_pay_sdk_ruby/models/create_payout_request'
require 'bleumi_pay_sdk_ruby/models/create_payout_response'
require 'bleumi_pay_sdk_ruby/models/ethereum_address'
require 'bleumi_pay_sdk_ruby/models/ethereum_balance'
require 'bleumi_pay_sdk_ruby/models/ethereum_wallet_address'
require 'bleumi_pay_sdk_ruby/models/ethereum_wallet_inputs'
require 'bleumi_pay_sdk_ruby/models/paginated_payment_operations'
require 'bleumi_pay_sdk_ruby/models/paginated_payments'
require 'bleumi_pay_sdk_ruby/models/paginated_payout_items'
require 'bleumi_pay_sdk_ruby/models/payment'
require 'bleumi_pay_sdk_ruby/models/payment_addresses'
require 'bleumi_pay_sdk_ruby/models/payment_balances'
require 'bleumi_pay_sdk_ruby/models/payment_operation'
require 'bleumi_pay_sdk_ruby/models/payment_operation_inputs'
require 'bleumi_pay_sdk_ruby/models/payment_operation_response'
require 'bleumi_pay_sdk_ruby/models/payment_refund_request'
require 'bleumi_pay_sdk_ruby/models/payment_settle_request'
require 'bleumi_pay_sdk_ruby/models/payout'
require 'bleumi_pay_sdk_ruby/models/payout_item'
require 'bleumi_pay_sdk_ruby/models/payout_item_inputs'
require 'bleumi_pay_sdk_ruby/models/rsk_address'
require 'bleumi_pay_sdk_ruby/models/rsk_balance'
require 'bleumi_pay_sdk_ruby/models/validate_checkout_request'
require 'bleumi_pay_sdk_ruby/models/validate_checkout_response'
require 'bleumi_pay_sdk_ruby/models/wallet_balance'

# APIs
require 'bleumi_pay_sdk_ruby/api/hosted_checkouts_api'
require 'bleumi_pay_sdk_ruby/api/payments_api'
require 'bleumi_pay_sdk_ruby/api/payouts_api'
require 'bleumi_pay_sdk_ruby/api/request_validator'

module BleumiPay
  class << self
    # Customize default settings for the SDK using block.
    #   BleumiPay.configure do |config|
    #     config.username = "xxx"
    #     config.password = "xxx"
    #   end
    # If no block given, return the default Configuration object.
    def configure
      if block_given?
        yield(Configuration.default)
      else
        Configuration.default
      end
    end
  end
end
